#include "liste.h"

liste listeNouv(){
    return NULL;
}

Bool estVideListe(liste laListe){
    return laListe == NULL;
}

Nat longueurListe(liste laListe){
    liste temp = laListe;
    Nat longueur = 0;

    while(temp != NULL){
        longueur++;
        temp = temp->suivant;
    }
    
    return longueur;
}

void afficheListe(liste laListe){
    if(estVideListe(laListe)){
        printf("Désolé : liste vide.\n");
    }else{
        liste temp = laListe;

        while (temp != NULL){
            printf("%d  ", temp->valeur);
            temp = temp->suivant;
        }
        printf("\n");
    }
}

//********************* Opérations sur la tête ****************************//

liste adjonctionEnTete(liste laListe, Nat valeurAAjouter){
    liste noeud = MALLOC(strListe);
    
    if(noeud == NULL){
        fprintf(stderr, "Erreur: Erreur allocation mémoire");
        exit(EXIT_FAILURE);
    }

    noeud->valeur = valeurAAjouter;

    //* Si la liste est vide alors le noeud est la liste
    if(estVideListe(laListe)){
        noeud->suivant = NULL;
        laListe = noeud;
    }else{
        noeud->suivant = laListe;
        laListe = noeud;
    }

    return laListe;
}

liste suppressionTete(liste laListe){
    //* Pre-condition : la liste a au moins un élément
    //* Cas un élément
    if(laListe->suivant == NULL){
        FREE(laListe);
        laListe = listeNouv();
    }
    //* Cas général :  Plus d'un élément
    else {
        liste teteAsupprimer = laListe;
        laListe = laListe->suivant;
        FREE(teteAsupprimer);
    }

    return laListe;
}

Nat teteListe(liste laListe){
    return laListe->valeur;
}

//*************************************************************************//


//


//************************* Opérations sur la queue ************************//
liste adjonctionEnQueue(liste laListe, Nat valeurAAjouter){
    //* Création du noeud à ajouter
    liste noeud = MALLOC(strListe);
    if( noeud == NULL){
        fprintf(stderr, "Erreur : allocation mémoire echouée");
        exit(EXIT_FAILURE);
    }

   noeud->valeur = valeurAAjouter;
   noeud->suivant = NULL;
   //* Cas où la liste est vide
   if(estVideListe(laListe)){
        laListe = noeud;
   }else {
        //* On cherche le dernier élément
        liste dernierNoeud = dernierNoeudListe(laListe);
        // printf("%p\n", dernierNoeud);
        dernierNoeud->suivant = noeud;
   }
   
}

//* On a besoin de cette fonction pour la queue 
liste dernierNoeudListe(liste laListe){
    liste dernier;
    liste temp = laListe;
    while(temp->suivant != NULL){
        // printf("%p\n", temp);
        temp = temp->suivant;
    }

    dernier = temp; 
    return dernier; 
}


//* On a besoin de cette fonction pour la supression.
//* Retourne l'addresse de l'avant dernier noeud.
liste avantDernierNoeudListe(liste laListe){
    liste avantDernier;
    liste temp = laListe;
    while(temp->suivant->suivant != NULL){
        // printf("%p\n", temp);
        temp = temp->suivant;
    }

    avantDernier = temp; 
    return avantDernier; 
}

//* Retourne la valeur se trouvant à la queue.
Nat queueListe(liste laListe){
    liste dernierNoueud = dernierNoeudListe(laListe);
    return dernierNoueud->valeur;
}

liste supressionQueue(liste laListe){
    //*
    liste avantDernier = avantDernierNoeudListe(laListe);
    liste dernier = dernierNoeudListe(laListe);
    FREE(dernier);
    avantDernier->suivant = NULL;

    return laListe;
}
//*************************************************************************

//****************** Opération sur le i-ème élément ***********************//
//* On en a besoin pour la fonction changement.
//* Retourne l'addresse de la 1 ère valeur qu'on cherche sinon NULL
liste rechercheNoeud(liste laListe, Nat valeurNoeudAChercher){
    while(laListe != NULL && laListe->valeur != valeurNoeudAChercher)
        laListe = laListe->suivant;

    if(laListe != NULL){
        // l'addresse du noeud a été trouvé.
        liste addresseNoeudTrouve = laListe;
        return addresseNoeudTrouve;
    }else
        return laListe;
}


liste changement(liste laListe , Nat valeurCourante, Nat nouvelleValeur){
    liste addresseDuNoeudAChanger = rechercheNoeud(laListe , valeurCourante);

    if(addresseDuNoeudAChanger != NULL){
        //* On n'a trouvé la valeur dans notre liste;
        addresseDuNoeudAChanger->valeur = nouvelleValeur;
    }
    // Sinon, on ne fait rien, au càs où l'addresse du noeud à changer
    // serait null;

    return laListe;
}

//* On en a besoin pour la fonction supprimeFirstOcc.
liste rechercheNoeudAvant(liste laListe, Nat valeurNoeudAChercher){
    while(laListe->suivant != NULL && laListe->suivant->valeur != valeurNoeudAChercher ){
        laListe = laListe->suivant;
    }

    if(laListe->suivant != NULL)
    {
        liste addresseNoeudAvantTrouve = laListe;
        return addresseNoeudAvantTrouve;
    }

    return laListe;
}

//* Supprime la 1 ère occurence.
liste supprimeFirstOcc(liste laListe, Nat valeurASupprimer){
    if(estVideListe(laListe)){
        return laListe; 
    }//* Cas à un seul élément.
    else if(laListe->valeur == valeurASupprimer && laListe->suivant == NULL){
        FREE(laListe);
        laListe = listeNouv();
        return laListe; 
    } //* Cas général
    else {
        liste noeudAvant = rechercheNoeudAvant(laListe, valeurASupprimer);
        if(noeudAvant->suivant != NULL){
            liste noeudASupprimer = noeudAvant->suivant;
            noeudAvant->suivant = noeudASupprimer->suivant;
            FREE(noeudASupprimer);
        }
    }


    return laListe;
}

