#include <stdio.h>
#include <math.h>

void afficheTab(int *tab, int taille){
    for(int i = 0 ; i < taille ; i++){
        printf("%d  ", tab[i]);
    }
    printf("\n");
}

int bitDeSigne(int *tableauDeBits){
    return tableauDeBits[0];
}

void getBitsExposantAvecExces(int *tableauDebits, int *exposantAvecExces){
    for(int i = 1 ; i < 9 ; i++){
        exposantAvecExces[i-1] = tableauDebits[i];
    }

    return;
}

//* Retourne l'exposant sans exces des 8 bits de l'exposant
int exposant(int* tabBitsExposant){
    int e = 0;
    int bit = 0;

    for(int i = 0 ; i < 8 ; i++) {
        bit = tabBitsExposant[i];
        e += bit << 7 - i ;
    }

    return e - 127;
}

void getBitsMantisseBiaisee(int *tableauDeBits, int* bitsMantissebiasee){
    for(int i = 9 ; i < 32; i++){
        bitsMantissebiasee[i - 9] = tableauDeBits[i];
    }

    return;
}

float mantisse(int* bitsMantisseBiasee){
    float m = 1.f ;
    float bit = 0.f;
    float puiss = 1.f / 2.f;

    for(int i = 0 ; i < 23; i++){
        bit = (float)bitsMantisseBiasee[i];

        //* Comment utiliser >> pour les puissances negatives;
        // m += bit >> i + 1;
        m += bit * puiss;
        puiss /= 2; 
    }

    return m;
}

void convert(int *tableauDeBits){
    int exposantAvecExces[8] ;
    int mantisseBiaisee[23];
    int exposantSansExces = 0;
    float laMantisse = 0.f;
    float deuxPuisExposant = 0.f;

    getBitsExposantAvecExces(tableauDeBits, exposantAvecExces);
    getBitsMantisseBiaisee(tableauDeBits, mantisseBiaisee);

    exposantSansExces = exposant(exposantAvecExces);
    deuxPuisExposant = pow(2.f, exposantSansExces);
    laMantisse = mantisse(mantisseBiaisee);
    
    printf("Nombre codee en IEEE vaut : %f\n", laMantisse*deuxPuisExposant);
}

int main(){
    int nombreCodeEnIEEE[32] = {0, 1, 0, 0, 0, 0, 1, 0, 1,  1, 0, 1, 0, 1, 0,
                                0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
                                0, 0};

    convert(nombreCodeEnIEEE);
    return 0;
}