ville(paris).
ville(orleans).
ville(strasbourg).
ville(mulhouse).
ville(colmar).
ville(nancy).
ville(toulouse).
ville(grenoble).

region('Ile de France').
region('Grand Est').
region('Auvergne Rhône Alpes').
region('Provence-Alpes-Côte d’Azur').
region('Centre- Val de Loire').

est_dans('rue des ecureuils', 'quartier de la gare').
est_dans('quartier de la gare', onzieme).
est_dans(onzieme, paris).
est_dans('lieu dit de l\'impasse', orleans).
est_dans('rue du renard prechant', krutenau).
est_dans(krutenau, strasbourg). 
est_dans('quartier des pecheur', 'zone du Rhin').
est_dans('zone du Rhin', strasbourg).
est_dans('rue Oberweg', 'banlieue ouest strasbourgeoise').
est_dans( 'banlieue ouest strasbourgeoise', strasbourg).
est_dans('rue Oberweg - Nancy', 'quartier de l hopital').
est_dans('quartier de l hopital', nancy).
est_dans('rue des bourgeois', 'quartier des bourgeois').
est_dans('quartier des bourgeois', colmar).
est_dans('rue des maçons', mulhouse).
est_dans(premier, paris).
est_dans('Ile de la Cité', premier).
est_dans('rue des Pyrénées', toulouse).

% 1 Associer chaque ville sa région
est_dans(strasbourg, 'Grand Est').
est_dans(colmar, 'Grand Est').
est_dans(mulhouse, 'Grand Est').
est_dans(nancy, 'Grand Est').
est_dans(paris, 'Ile de France').
est_dans(toulouse, 'Occitanie').
est_dans(grenoble, 'Auvergne Rhône Alpes').
est_dans(orleans, 'Centre- Val de Loire').

% Dans quelle region se trouve grenoble
% est_dans(grenoble, Y).

% Les villes du Grand Est
% ?- ville(X), est_dans(X, 'Grand Est').
% est_dans(X, 'Grand Est').

% 2 La ville de Hans-Hubert Worm
% Il faudra aussi inclure le fichier etudiants.pl
% habite('Hans-Hubert Worm', 0, X).









% Les listes 
% Longueur d'une liste

size([]     , 0 ).
size([_|Xs] , L ) :- size(Xs,N) , L is N+1 .

% Appartenance
% Si c'est la même tête alors il y est.
estDans(Elem, [Elem| _]).

% Sinon on cherche dans la queue.
estDans(Elem, [_ | L]):- estDans(Elem, L). 

% 2-
% N-ieme element de la liste.

nieme(0, [T|_], T).
nieme(Pos, [_|R], X):- Pos > 0, NouvPos is Pos - 1, nieme(NouvPos, R, X).

% 3
% Concaténation de deux liste
% Concaténation d'une liste vide et autre liste, on obtient cette autre liste
concatL([], L, L).
% sinon, c'est la tête T et le resulat de la concaténation du reste de la
% 1 ère liste et la deuxième liste.
concatL([T|R], L, [T|L1]):- concatL(R, L, L1).

% Retourner (Renverser une liste)
retourner([], []). % Ceci est une clause.
retourner([T|R], ListeRenverse):-
    retourner(R, ResteListeRenverse), concatL(ResteListeRenverse, [T], ListeRenverse).

% Trie d'une liste. (Quesion supplementaire)
% On a besoin d'une fonction auxiliaire inserer_elt dans une liste triée.
inserer_elt(Valeur, [], [Valeur]).

inserer_elt(Valeur, [T|R], [Valeur|[T|R]]):-
    Valeur =< T .

inserer_elt(Valeur, [T|R], [T|R1]):-
    Valeur > T, inserer_elt(Valeur, R, R1).

trierListe([], []).
trierListe([T|R], ListeTriee):-
    trierListe(R, ResteTriee),
    inserer_elt(T, ResteTriee, ListeTriee).

% 4 - Mettre à plat une liste.
mettreAPlat([], []).

mettreAPlat([T|R], [T|ListPlat]):-
    atomic(T), 
    mettreAPlat(R, ListPlat).

mettreAPlat([T|R], ListePlat):-
    not(atomic(T)),
    mettreAPlat(T, ListePlatT),
    mettreAPlat(R, ListePlatR),
    concatL(ListePlatT, ListePlatR, ListePlat).



