#include <stdio.h>
#include <stdbool.h>

#define MAX_ITEMS 100

// typedef int ref;
typedef unsigned int nat;

// typedef bool Bool;
// #define vrai true;
// #define faux false;

typedef struct Item {
    nat ref;
    int quantity;
}item;

typedef struct Stock{
    item items[MAX_ITEMS];
    int amountOfRef;
}stock;

//* Creation of an empty Stock
stock creerStock(){
    stock theStock;
    theStock.amountOfRef = 0;

    return theStock;
};

//* Creation of new item
item createNewItem(nat r, nat q){
    item newItem = {r, q};

    // We can also procede as bellow
    // newItem.itemRef = r;
    // newItem.quantity = q;
    return newItem;
}

//* Add a new ref with it's quantity to our stock
stock addNewRef(stock theStock, ref itemRef, nat itemQuantity){
    item newItem = createNewItem(itemRef, itemQuantity);
    int currentAmount = theStock.amountOfRef;
    theStock.items[currentAmount] = newItem;

    theStock.amountOfRef++;
    return theStock;
}

bool isStockEmpty(stock theStock){
    if(theStock.amountOfRef == 0){
        return true;
    }else {
        return false;
    }
}

bool isRefInStock(stock theStock, nat itemRef){
    if(isStockEmpty(theStock)){
        return false;
    }
    else if(theStock.items[theStock.amountOfRef - 1].ref == itemRef){
    // item lastItem = theStock.items[theStock.amountOfRef - 1];
        return true;
    }else {
        theStock.amountOfRef--;
        isRefInStock(theStock, itemRef);
    }
}

stock deleteRef(stock theStock, nat itemRef){
    //* pre : itemRef belongs to the Stock
    item lastItem = theStock.items[theStock.amountOfRef - 1];

    if(lastItem.ref == itemRef){
        // lastItem.ref = -1; //* tell it's no longer a ref
        theStock.items[theStock.amountOfRef - 1].ref = - 1;
        theStock.items[theStock.amountOfRef - 1].quantity = 0;


        // lastItem.quantity = 0;
        theStock.amountOfRef--; //* once deleted, the amount of ref decrease
        return theStock;
    }else {
        theStock.amountOfRef--;
        stock anotherStock = deleteRef(theStock, itemRef);
        return addNewRef(anotherStock, lastItem.ref, lastItem.quantity);
    }
}



void displayStock(stock theStock){
    printf("{\n");
    int i;
    for( i = 0 ; i < theStock.amountOfRef; i++){
        item stockItem = theStock.items[i];
        printf("{ref : %d, quatity : %d},\n", stockItem.ref, stockItem.quantity );
    }
    printf("}\n");
}



int main(){
    stock myStock = creerStock();
    myStock = addNewRef(myStock, 1, 23);
    myStock = addNewRef(myStock, 2, 234);
    printf("Before deleting : \n");
    displayStock(myStock);
    printf("\n");

    myStock = deleteRef(myStock, 2);
    printf("After deleting : \n");
    displayStock(myStock);


    // if(isRefInStock(myStock, 2)){
    //     printf("Reference trouvée\n");
    // }else {
    //     printf("Reference non trouvée\n");
    // }
    return 0;
}