#include <stdio.h>
#include "gestionDeStock.h"

void afficherLeStock(stock leStock){
    printf("➖➖➖➖➖➖➖➖➖➖➖➖➖➖➖➖➖➖\n");
    printf("┃            Mon Stock             ┃\n");
    printf("➖➖➖➖➖➖➖➖➖➖➖➖➖➖➖➖➖➖\n");
    printf("┃{                                 ┃\n");
    for(int i = 0 ; i < leStock.nombreDeRef ; i++ ){
        printf("┃  {                               ┃\n");
        printf("┃     Reference : %d,               ┃\n", leStock.tabDeProduit[i].ref);
        printf("┃     Quantite : %d,              ┃\n", leStock.tabDeProduit[i].quantite);
        printf("┃  },                              ┃\n");
    }
    printf("┃}                                 ┃\n");
    printf("➖➖➖➖➖➖➖➖➖➖➖➖➖➖➖➖➖➖\n");
}

stock creerStock(){
    stock leStock;
    
    leStock.tabDeProduit = MALLOCN(produit, MAX);

    // Au cas où l'allocation echoue
    if(leStock.tabDeProduit == NULL){
        fprintf(stderr, "Erreur : probleme allocation dynamique.\n");
		exit(EXIT_FAILURE);
    }

    leStock.taille = MAX;
    leStock.nombreDeRef = 0;
    printf("%d\n",leStock.nombreDeRef);
    printf("Le stock vide a bien été creé ✅️.\n");
    return leStock;
}

stock ajouteNouveauProduit(stock leStock, Nat refereceDuProduit, Nat quantiteDuProduit){
    Nat i = leStock.nombreDeRef;

    leStock.tabDeProduit[i].ref = refereceDuProduit;
    leStock.tabDeProduit[i].quantite = quantiteDuProduit;
    leStock.nombreDeRef++;
    printf("Le nouveau produit a bien été ajouté ✅️.\n");
    return leStock;
}

stock newRef(stock leStock, Nat refereceDuProduit, Nat quantiteDuProduit){
    // si notre tab de produit est plein, on réalloue MAX cases
    if(leStock.nombreDeRef == leStock.taille){
        produit *tabDeProduitTemp = leStock.tabDeProduit;
        Nat nouvelleTailleDuTabDeProd = leStock.taille + MAX;
        leStock.tabDeProduit = REALLOC(leStock.tabDeProduit, produit, nouvelleTailleDuTabDeProd);

        if(leStock.tabDeProduit == NULL){
            printf("Erreur : Reallocation echouée");
            leStock.tabDeProduit = tabDeProduitTemp;
        }else {
            leStock.taille = nouvelleTailleDuTabDeProd;
            Nat i = leStock.nombreDeRef;

            // leStock.tabDeProduit[i].ref = refereceDuProduit;
            // leStock.tabDeProduit[i].quantite = quantiteDuProduit;

            // leStock.nombreDeRef++;

            leStock = ajouteNouveauProduit(leStock, refereceDuProduit, quantiteDuProduit);
            printf("Reallocation terminée et produit ajouté.\n");
        }
    }else {
        // Nat i = leStock.nombreDeRef;

        // leStock.tabDeProduit[i].ref = refereceDuProduit;
        // leStock.tabDeProduit[i].quantite = quantiteDuProduit;
        // leStock.nombreDeRef++;
        //* ajouteNouveauProduit : est une fonction auxiliaire
        leStock = ajouteNouveauProduit(leStock, refereceDuProduit, quantiteDuProduit);
    }
    
    return leStock;
}

Nat getAmountOfRef(stock leStock){
    return leStock.nombreDeRef;
}

Bool existeRef(stock leStock, Nat refAChercher){
    // Nat refDansStock = leStock.tabDeProduit[leStock.nombreDeRef - 1].ref;
    // Pourquoi en mettant refDansStock ne marche pas?
    if( leStock.nombreDeRef == 0){
        return faux;
    } else if( leStock.tabDeProduit[leStock.nombreDeRef - 1].ref == refAChercher){
        return vrai;
    }else {
        leStock.nombreDeRef = leStock.nombreDeRef - 1;
        return existeRef(leStock, refAChercher);
    }
}

stock deleteRef(stock leStock, Nat refrefASupprimer){
    // Pré : La ref à effacer existe dans le stock
    Nat refTrouvee = faux;

    for( int i = 0 ; i < leStock.nombreDeRef && !refTrouvee ; i++){
        if( leStock.tabDeProduit[i].ref == refrefASupprimer){
            Nat indiceDernierProduit = leStock.nombreDeRef - 1;
            produit dernierProduit = leStock.tabDeProduit[indiceDernierProduit];

            //* la supression consiste à remplacer la ref du produit à supprimer 
            //* par le dernier produit du stock;
            leStock.tabDeProduit[i] = dernierProduit;
            leStock.nombreDeRef--;
            refTrouvee = vrai;
            printf("Produit supprimé👌️.\n");
        }
    }

    return leStock;
}

Nat getQuantityOfRef(stock leStock, Nat refQuantiteAChercher){
    // Pre : La ref existe dans le stock
    Bool refTrouvee = faux;
    Nat quantiteDeLaRef;
    for(int i = 0 ; i < leStock.nombreDeRef && !refTrouvee; i++){
        if(leStock.tabDeProduit[i].ref == refQuantiteAChercher){
            quantiteDeLaRef = leStock.tabDeProduit[i].quantite;
            refTrouvee = vrai;
        }
    }

    return quantiteDeLaRef;
}

