//* Pour une mesure de sécurité en plus pour le processeur
#ifndef __STOCK_H
#define __STOCK_H

#include "base.h"

//* Le maximum de produit dans le stock
#define MAX 1000

//* Définition d'un produit
typedef struct Produit {
    Nat ref;
    Nat quantite;
}produit;

//* Définition d'un stock
//* On décide que si ref = 0 alors la case est disponible
//* Si toutes les ref sont à zero alors le stock est vide
typedef produit stock[MAX]; //* Un tableau de MAX produit


//* Prototypes
void afficherLeStock(stock leStock);

//* Création d'un stock vide
void creerStock(stock leStock); 

//* Ajout d'une nouvelle reférence
void newRef(stock leStock, Nat refDuProduit, Nat quantiteDuProduit); 

//* Nombre de reference du stock
Nat getAmountOfRef(stock leStock);

//* Est-ce que la reference existe?
Bool existeRef(stock leStock, Nat refAChercher);

//* Supprime la reference dans le stock
void deleteRef(stock leStock, Nat refrefASupprimer);

//* Quantite d'une reference
Nat getQuantityOfRef(stock leStock, Nat ref);


#endif
