#include "clans.h"
#include "base.h"

//* Personnes
personne createPersonne(Nat id, Nat age, char genre){
    personne p;
    p.personneId = id;
    p.personneAge = age;
    p.genre = genre;

    return p;
}

Nat getPersId(personne laPersonne){
    return laPersonne.personneId;
}

Nat getPersAge(personne laPersonne){
    return laPersonne.personneAge;
}

char getPersGenre(personne laPersonne){
    return laPersonne.genre;
}


//*------------------------------------ Les clans ------------------------
population newPop(){
    // population populationVide = MALLOC(membre);
    
    // if(populationVide == NULL){
    //     fprintf(stderr, "Erreur: Allocation échouée.");
    // }

    // populationVide->nextComp = NULL;
    // populationVide->nextPop = NULL;
    return NULL;

}

clans newClans(){
    // clans clansVide = MALLOC(stClan);

    // if(clansVide == NULL){
    //     fprintf(stderr, "Erreur: Allocation échouée.");
    //     exit(EXIT_FAILURE);
    // }

    // clansVide->premier = NULL;
    // clansVide->dernier = NULL;
    // clansVide->nextClan = NULL;

    return NULL; //*clansVide;
}

jeu jeuVide(){
    jeu jeuVide;

    jeuVide.pop = newPop();
    jeuVide.listeClans = newClans();

    return jeuVide;
}

membre* jeuAddresseChef(membre* membreDuClan){
    //* membreDuClan est non NULL.
    membre* chef = membreDuClan;
    if(chef->nextComp == NULL){
        return chef;
    }else {
        while(chef->nextComp != NULL){
            chef = chef->nextComp;
        }
        return chef;
    }
}
//* c-) 
void printMembre(membre *leMembre){
    printf("{\n");
    printf("    nom : %d,\n", leMembre->per.personneId);
    printf("    age : %d,\n", leMembre->per.personneAge);
    printf("    nom : '%c'\n", leMembre->per.genre);
    printf("},\n");
}

void jeuPrintPop(jeu j){
    population membreTemp = j.pop;
    printf("[");
    while(membreTemp != NULL){
        printMembre(membreTemp);
        membreTemp = membreTemp->nextPop;
    }
    printf("]\n");
}

Bool estMembreDansLeClan(clans listeClans, membre *membreClan){
    population membreTemp = listeClans->premier;
    Bool trouve = faux;

    while(membreTemp != NULL && !trouve){
        if(membreTemp == membreClan){
            trouve = vrai;
        }
        membreTemp = membreTemp->nextComp;
    }

    return trouve;
}

void printMembresClan(clans leClan){
    membre *membreTemp = leClan->premier;
    while (membreTemp != NULL)
    {
        printMembre(membreTemp);
        membreTemp = membreTemp->nextComp;
    }
}
void jeuPrintClan(jeu j, membre* membreClan){
    //* Pré-condition : *membreClan appartient à un clans dans le Jeu.
    clans listeClans = j.listeClans;
    //* Il faut chercher à savoir quel clan le joueur appartient-il?
    clans clanDuJoueur = NULL;
    clans clanTemp = listeClans;

    Bool clanTrouve = faux;

    while(clanTemp != NULL && !clanTrouve){
        if(estMembreDansLeClan(clanTemp, membreClan)){
            clanTrouve = vrai;
        }
    }
    //* le clan est trouvé
    printMembresClan(clanTemp);
}

//* d-) Fusion des clans.

clans getClanAvant(clans listeClans, clans clanCourrant){
    //* Pré-condition : longueur (ListeClans) >= 2 et listeClans != clanCourrant
    clans clanTemp = listeClans;

    while(clanTemp->nextClan != clanCourrant){
        clanTemp = clanTemp->nextClan;
    }

    return clanTemp;
}

jeu jeuFusion(jeu j, clans clan1, clans clan2){
    //* Pré-condition : clan1 et clan2 non NULL
    //* Hypothese : le chef du clan1 le restera après la fusion

    clan2->dernier->nextComp = clan1->premier;
    clan1->premier = clan2->premier;
    clan2->premier = NULL;
    
    //* On a besoin de l'addrese du clan avant le clan2, pour effectuer la
    //* la suppression du clan2.
    clans clanAvantClan2 = getClanAvant(j.listeClans, clan2);
    clanAvantClan2->nextClan = clan2->nextClan;
    FREE(clan2);

    return j;
}

//* e-)
population creerMembre(Nat id, Nat age, char genre){
    personne p = createPersonne(id, age, genre);
    population unMembre = MALLOC(membre);

    if(unMembre == NULL){
        fprintf(stderr, "Erreur : Allocation échouée.");
        exit(EXIT_FAILURE);
    }

    unMembre->per = p;
    unMembre->nextComp = NULL;
    unMembre->nextPop = NULL;

    return unMembre;
}

Bool estVideClans(clans unClans){
    return unClans->premier == NULL;
}

clans getClansOuAjouter(clans listeClans, Nat position){
        //* Pré-condition : position >= 1

        clans temp = listeClans ;
        Nat posCur = 1;
        while(posCur != position && temp != NULL){
            posCur++;
            temp = temp->nextClan;
        }

        return temp;
}

clans ajoutEnTeteMembre(clans clansOuAjouter, population unMembre){
    //* Cas simple (le clans est vide)
    if(estVideClans(clansOuAjouter)){
        clansOuAjouter->premier = unMembre;
        clansOuAjouter->dernier = unMembre;
    }else {
        //* Cas général 
        unMembre->nextComp = clansOuAjouter->premier ;
        clansOuAjouter->premier = unMembre ;
    }

    return clansOuAjouter;
}

clans getDernierClans(clans listeClans){
    clans temp = listeClans;

    while(temp->nextClan != NULL){
        temp = temp->nextClan;
    }
    return temp;
}

clans ajoutEnQueueClans(clans listeClans, clans clanAAjouter){
    clans dernier = getDernierClans(listeClans);
    dernier->nextClan = clanAAjouter;

    return listeClans;
}


Bool estJeuVide(jeu j){
    return j.listeClans == NULL;
}

Bool estIdExiste(population listePop, Nat persId){
    Nat trouve = faux;
    population temp = listePop;
    while(temp != NULL && !trouve){
        if(temp->per.personneId == persId){
            trouve = vrai;
        }
        temp = temp->nextPop;
    }

    return trouve;
}

population getOuInserer(population listePop, Nat persId){
    population temp = listePop;

    while(temp->per.personneId < persId && temp->nextPop != NULL){
        temp = temp->nextPop;
    }
    return temp;
}


population getAddAvant(population listePop, population finSousListePop){
    //* Pré-condition : finSousListePop est une sous liste de listePop
    population temp = listePop;

    while(temp->nextPop != finSousListePop){
        temp = temp->nextPop;
    }
    return temp;
}

population ajoutEnTete(population listePop, population unMembre){
    //* Cas simple ( liste vide)
    if(listePop == NULL){
        listePop = unMembre;
    }else {
        unMembre->nextPop = listePop;
        listePop = unMembre;
    }
    return listePop;
}

jeu ajoutMembreDansUnClans(jeu j, personne p){
    //* Cas simple (Il n'y a aucun joueur dans le jeu).
    population unMembre = creerMembre(p.personneId, p.personneAge, p.genre);

    if(estJeuVide(j)){
        //* On crée un nouveau jeu, on y ajoute le clan dans lequel il y 
        //* a le nouveau memebre.
        jeu nouveauJeu;

        clans unClan = MALLOC(stClan);

        if(unClan == NULL){
            fprintf(stderr, "Erreur : Allocation échouée.");
            exit(EXIT_FAILURE);
        }

        unClan->premier = unMembre ;
        unClan->dernier = unMembre ;
        unClan->nextClan = NULL ;

        j.listeClans = unClan ;
        j.pop = unMembre;
    }else{
        //* Le jeu n'est pas vide,
        //* Il faut faire une adjonction en Queue du nouveau clan avec le membre
        clans nouveauClan = MALLOC(stClan);

        if(nouveauClan == NULL){
            fprintf(stderr, "Erreur: Allocation échouée.");
            exit(EXIT_FAILURE);
        }

        nouveauClan->premier = unMembre ;
        nouveauClan->dernier = unMembre ;
        nouveauClan->nextClan = NULL ;
        j.listeClans = ajoutEnQueueClans(j.listeClans, nouveauClan);
        //* Il faut inserer ce nouveau joueur en se basant sur son identifiant
        //* Vérifier que l'identifiant n'est pas utilisé et l'inserer de sorte
        //* que ts les joueurs soient croissant selon identifiant.
        Bool idExiste = estIdExiste(j.pop, p.personneId);
        if(idExiste == faux ){
            //* On cherche la bonne place où l'inserer.
            population ouInserer = getOuInserer(j.pop, p.personneId);
            if(ouInserer->nextPop == NULL && j.pop != ouInserer){
                //* ça veut dire que son id est plus grand que tous ceux dans la
                //* liste, donc on l'insere à la fin.
                ouInserer->nextPop = unMembre;
            }else {
                if(j.pop == ouInserer){
                    //* On fait une insertion en tête.
                    j.pop = ajoutEnTete(j.pop, unMembre);
                }else {
                    population avant = getAddAvant(j.pop, ouInserer);
                    population apres = avant->nextPop ;
                    avant->nextPop = unMembre;
                    unMembre->nextPop = apres;
                }
            }
        }else{
            printf("Désolé, l'identifiant existe déjà.\n");
        }
    }
    
    return j; 
}