#ifndef __CLANS_H
#define __CLANS_H

#include "base.h"

typedef struct Personne{
    Nat personneId;
    Nat personneAge;
    char genre;
}personne;

//* Les clans
typedef struct stPer{
    personne per;           // les données de la personne.
    struct stPer *nextComp; // Le compagnon suivant dans le clan.
    struct stPer *nextPop;  // La personne suiv. dans la population.
}membre, *population;

typedef struct stClan{
    membre *premier;        // Début de la liste du clan.
    membre *dernier;        // Le dernier est le représentant.
    struct stClan *nextClan;//* Chaînage
}stClan, *clans;

typedef struct {
    population pop;         //* Liste de la population entière.
    clans listeClans;          //* Liste des clans.
}jeu;

//* Opérations
//* Une personne
personne createPersonne(Nat id, Nat age, char genre);

Nat getPersId(personne laPersonne);

Nat getPersAge(personne laPersonne);

char getPersGenre(personne laPersonne);

//*----------------------- Les clans ------------------------
membre* jeuAddresseChef(membre* membreDuclan);

population newPop();

clans newClans();

jeu jeuVide();

population creerMembre(Nat id, Nat age, char genre);

Bool estVideClans(clans unClans);

clans getClansOuAjouter(clans listeClans, Nat position);

clans ajoutEnTeteMembre(clans clansOuAjouter, population unMembre);

//*--------------- Fonctions auxiliaire pour ajoutMembreDansUnClans---------//
clans getDernierClans(clans listeClans);
clans ajoutEnQueueClans(clans listeClans, clans clanAAjouter);
Bool estJeuVide(jeu j);
Bool estIdExiste(population listePop, Nat persId);
population getOuInserer(population listePop, Nat persId);
population getAddAvant(population listePop, population finSousListePop);
population ajoutEnTete(population listePop, population unMembre);
//*------------------------------------------------------------------------//
jeu ajoutMembreDansUnClans(jeu j, personne p);
//*--------------------------------------------------------------------//
void jeuPrintPop(jeu j);
//*--------------- Fonctions auxiliaires pour jeuPrintClan-------------//
void printMembre(membre *leMembre);
Bool estMembreDansLeClan(clans listeClans, membre *membreClan);
void printMembresClan(clans leClan);
//*-------------------------------------------------------------------//
void jeuPrintClan(jeu j, membre *membreClan);
//*--------------------------------------------------------------------//

clans getClanAvant(clans listeClans, clans clanCourrant);
jeu jeuFusion(jeu j, clans clan1, clans clan2);

#endif