#include <stdio.h>
#include <stdbool.h>

typedef bool Boolean;
#define faux false;
#define vrai true;

typedef unsigned int Nat;

typedef struct ens {
    int tab[100];
    int n;
} Ens;

Ens ensVide(){
    Ens e;
    e.n = 0;

    return e;
}

Ens insertion(Ens e, Nat valeur){
    // Pre :
    // x n'appartient pas a 
    // card(e) < 100;
    e.tab[e.n] = valeur;
    
    e.n++; /* nouveau card */

    return e;
}

void afficheEns(Ens e){
    if( e.n != 0 ){
        printf("[");
        int i;
        for(i = 0 ; i < e.n - 1 ; i++){
            printf("%d, ", e.tab[i]);
        }
        printf("%d]\n", e.tab[i]);
    }else {
        printf("Ensemble Vide !");
    }
}

Boolean app(Ens e, Nat x){
    // Nat indDernierElt = e.n - 1 ;
    // Nat dernierElt = e.tab[indDernierElt];
    // if( x == dernierElt){
    //     return true;
    // }else if( e.n == 0 ) {
    //     return false;
    // } else {
    //     e.n = e.n - 1;
    //     return app(e, x);
    // }

    if( e.n == 0){
        return false;
    }else if(e.tab[e.n - 1] == x) {
        return true;
    }else {
        e.n = e.n - 1;
        return app(e, x);
    }
}

//* On se rapproche de la version itterative en utilisant une f(.) intermediare
//* ça ne marche pas, demande à la prof après
Boolean app2(Ens e, Nat x, Nat i){
    if(e.n == 0) {
        return false;
    }else if(e.tab[i-1] == x){
        return true;
    }else {
        i = i - 1;
        return app2(e, x, i);
    }
}

// Devoir : On écrit app2 en effectuant le parcours de gauche à droite
Boolean _app2(Ens e, Nat x, Nat i) {
    if(i == e.n){
        return false;
    }else if ( e.tab[i] == x) {
        return true;
    }else {
        i = i + 1;
        return _app2(e, x, i);
    }

}

Boolean appAvecFIntermediare(Ens e, Nat x){
    return _app2(e, x, 0);
}
Ens suprimer(Ens e, Nat x){
    // Pre : x app e
    Nat dernierElt = e.tab[e.n - 1];

    if( dernierElt == x) {
        e.tab[e.n - 1] = 0; //* En realité, on met juste sa valeur à 0
        e.n = e.n - 1;      //* Et on diminue le nombre d'elt pour ne pas 
                            //* qu'on y accede
        return e;
    }else {
        e.n = e.n - 1; //* on lui donne un ens plus petit
        Ens e1 = suprimer(e, x);
        return insertion(e1 , dernierElt); // On insert dernierElt à nouveau
                                            // car c'est pas l'element qu'on veut supprimer
    }
    
}
int main(){
    Ens e = ensVide();
    e = insertion(e, 3);
    e = insertion(e, 4);
    e = insertion(e, 5);
    afficheEns(e);

    Boolean appartientIl = app(e, 9);
    if(appartientIl == true){
        printf("Valeur trouvée!\n");
    }else {
        printf("Valeur non trouvée!\n");
    }

    // e = suprimer(e, 5);
    e = suprimer(e, 3);
    afficheEns(e);
    e = suprimer(e, 5);
    afficheEns(e);

        e = suprimer(e, 4);
    afficheEns(e);

    return 0;
}